-- Astra - Application Manager
-- c2011 LWI

require "lfs"

function init()
	print "[module] astra - application manager"

	width = 854
	height = 480

	-- define some colours
	grey  = xcore.xcolour(255, 60, 60, 60)
	ltgrey = xcore.xcolour(255, 222, 222, 222)
	white = xcore.xcolour(255, 255, 255, 255)
	black = xcore.xcolour(255, 0, 0, 0)
	clear = xcore.xcolour(0, 0, 0, 0)
	
	sim = xcore.xsimulation ( xcore.XDT_OPENGL, width, height, 16, false, false, false  )
	sim:setWindowCaption( "Astra - Application Manager" )
	sim:setColour( grey )
	
	sim:setSkinColor ( xcore.XGDC_GRAY_TEXT, white ) -- wtf?
	-- sim:setSkinColor ( xcore.XGDC_BUTTON_TEXT, white )
	
	font = sim:getBuiltInFont()	
	font_1 = sim:getFont( "modules/default/resources/font_tahoma_10.bmp" )
	font_2 = sim:getFont( "modules/default/resources/font_tahoma_10.bmp" )
	font_3 = sim:getFont( "modules/default/resources/font_tahoma_10.bmp" )	

	sim:setFont( font_1,  0 )-- default
	sim:setFont( font_1,  1 )
	sim:setFont( font_1,  2 )
	sim:setFont( font_1,  3 )	
	
	-- background
	texture_bg = sim:getTexture( "modules/default/resources/background.png" )
	image_bg = sim:addImage( 0, texture_bg, xcore.x2dpoint(200, 0),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	
	-- image spot for thumbnail modulename.jpg (should be png?)
	x = 210
	y = 10
	texture_module = sim:getTexture( "modules/default/resources/default.png" )
	image_module = sim:addImage( 2, texture_module, xcore.x2dpoint(x, y), xcore.x2drect(0,0,300,200), xcore.xcolour(255,255,255,255) )
	
	-- text fields for project name, url, author, liscence, & about text.
	x = 210
	y = 310
	text_module_desc = sim:addText( 0, "Desc:",x, y, x+344, y+280)	
	text_module_desc:setFont( font_1 )
	x = 605
	y = 10
	text_module_name = sim:addText( 0, "App:", x, y, x+300, y+20)
	text_module_desc:setFont( font_3 )	
	y = y +20
	text_module_dev = sim:addText( 0, "Dev:",x, y, x+300, y+20)	
	text_module_desc:setFont( font_1 )
	y = y +20
	text_module_ver = sim:addText( 0, "Ver:",x, y, x+300, y+20)	
	text_module_ver:setFont( font_1 )
	y = y +20
	
	-- button graphics
	texture_games = sim:getTexture( "modules/default/resources/button_games.png" )
	texture_tools = sim:getTexture( "modules/default/resources/button_tools.png" )
	texture_source = sim:getTexture( "modules/default/resources/button_source.png" )
	texture_large = sim:getTexture( "modules/default/resources/button_large.png" )
	texture_small = sim:getTexture( "modules/default/resources/button_small.png" )
	
	-- catagory buttons
	btn_w = 200
	btn_h = 58
	x = 0
	y = 10
	button_games = sim:addButton( 121, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "" )
	button_games:setImage( texture_games )
	button_games:setPressedImage( texture_games )
	y = y+68
	button_tools = sim:addButton( 122, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "" )
	button_tools:setImage( texture_tools )
	button_tools:setPressedImage( texture_tools )	
	y = y+68
	button_source = sim:addButton( 123, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "" )
	button_source:setImage( texture_source )
	button_source:setPressedImage( texture_source )	
	
	x = 0
	y = y + 68
	-- app list
	listbox_apps = sim:addListbox( 201, true, xcore.x2drect( x,y,x+200,y+258 ) )
	
	-- application buttons
	btn_w = 195
	btn_h = 58
	btn_hs = 29
	x = 605
	y = 130
	button_launch = sim:addButton( 101, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Launch" )	
	button_launch:setImage( texture_large )
	button_launch:setPressedImage( texture_large )	
	y = y+68	
	button_home    = sim:addButton( 111, xcore.x2drect( x, y, x+btn_w, y+btn_hs ), "Home" )
	button_home:setImage( texture_small )
	button_home:setPressedImage( texture_small )
	y = y+39
	button_readme    = sim:addButton( 112, xcore.x2drect( x, y, x+btn_w, y+btn_hs ), "Readme" )
	button_readme:setImage( texture_small )
	button_readme:setPressedImage( texture_small )
	y = y+39
	button_view_source    = sim:addButton( 113, xcore.x2drect( x, y, x+btn_w, y+btn_hs ), "View Source" )
	button_view_source:setImage( texture_small )
	button_view_source:setPressedImage( texture_small )
	
	-- variables!
	modules = {}
	module_count = 0
	current_module = 1

	-- search through modules directory and build table of local module data
	listModules()
	showModule( current_module )
	-- todo:que server for remote module data

	sim:bindkey ( "quit",  xcore.XKEY_ESCAPE  ) -- exit!
	sim:bindGUI ( "button_launch_pressed", 101, xcore.XGUI_BUTTON_CLICKED )

	sim:bindGUI ( "button_home_pressed", 111, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_readme_pressed", 112, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_view_source_pressed", 113, xcore.XGUI_BUTTON_CLICKED )
	
	sim:bindGUI ( "button_games_pressed", 121, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_tools_pressed", 122, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_source_pressed", 123, xcore.XGUI_BUTTON_CLICKED )

	sim:bindGUI ( "listbox_apps_changed", 201, xcore.XGUI_LISTBOX_CHANGED )
	sim:bindGUI ( "listbox_apps_changed_again", 201, xcore.XGUI_LISTBOX_SELECTED_AGAIN )

	showCatagory( "games" )
	setSidebar(1)	
end

function render()
	-- print "[module] render"
	sim:render()
end

function update()
	-- print "[module] update"
	sim:update()
	if sim:isKey( "quit" ) then sim:destroy() end
	if sim:isGUI( "button_launch_pressed" ) then
		os.execute( "xenos.exe " .. modules [ current_module ]["file"] )
	end
	
	if sim:isGUI( "button_games_pressed" ) then
		showCatagory( "games" )
		setSidebar(1)		
	end
	if sim:isGUI( "button_tools_pressed" ) then
		showCatagory( "tools" )		
		setSidebar(2)		
	end
	if sim:isGUI( "button_source_pressed" ) then
		showCatagory( "source" )
		setSidebar(3)		
	end

	if sim:isGUI( "button_home_pressed" ) then
		print("button_home_pressed")
		os.execute( "explorer.exe http://" .. modules [ current_module ]["home"] )
	end	
	if sim:isGUI( "button_readme_pressed" ) then
		print("button_readme_pressed")
		os.execute( "notepad.exe " .. "modules/".. modules [ current_module ]["file"] .. "/" .. modules [ current_module ]["readme"] )
	end
	if sim:isGUI( "button_view_source_pressed" ) then
		os.execute( "notepad.exe " .. "modules/".. modules [ current_module ]["file"] .. "/" .. modules [ current_module ]["file"] .. ".lua" )
	end
	if sim:isGUI( "listbox_apps_changed" ) then getModule( listbox_apps:getItem( listbox_apps:getSelected() ) ) end
	if sim:isGUI( "listbox_apps_changed_again" ) then getModule( listbox_apps:getItem( listbox_apps:getSelected() ) ) end
end

function showCatagory( n )
	print("showCatagory")
	listbox_apps:clear()
	for i = 1, table.getn( modules ) do
		if modules [ i ]["cat"] == n then
			listbox_apps:addItem( modules[i]["module"] )
		end
	end
end

function setSidebar ( p )
	x = 0
	y = 10
	if p == 1 then
		button_games:setPosition( xcore.x2dpoint(x, y) )
		y = y+68
		listbox_apps:setPosition( xcore.x2dpoint(x, y) )
		y = y+268
		button_tools:setPosition( xcore.x2dpoint(x, y) )
		y = y+68
		button_source:setPosition( xcore.x2dpoint(x, y) )
		
	elseif p == 2 then
		button_games:setPosition( xcore.x2dpoint(x, y) )
		y = y+68
		button_tools:setPosition( xcore.x2dpoint(x, y) )
		y = y+68
		listbox_apps:setPosition( xcore.x2dpoint(x, y) )
		y = y+268		
		button_source:setPosition( xcore.x2dpoint(x, y) )
	
	elseif p == 3 then
		button_games:setPosition( xcore.x2dpoint(x, y) )
		y = y+68
		button_tools:setPosition( xcore.x2dpoint(x, y) )
		y = y+68
		button_source:setPosition( xcore.x2dpoint(x, y) )
		y = y+68		
		listbox_apps:setPosition( xcore.x2dpoint(x, y) )
	end
	listbox_apps:setSelected( 0 )
	getModule( listbox_apps:getItem(0) )
end

function getModule( name )
	for i = 1, table.getn( modules ) do
		if modules [ i ]["module"] == name then
			showModule( i )
			current_module = i
		end
	end
end

function showModule( n ) -- by index
	-- print ("showing module " .. n )
	text_module_name:setText ( "" )
	text_module_dev:setText ( "" )
	text_module_desc:setText ( "" )
	text_module_ver:setText ( "" )
	button_home:setVisible( false )
	button_readme:setVisible( false )
	button_view_source:setVisible( false )	

	if modules [ n ]["module"] ~= nil then text_module_name:setText ( modules [ n ]["module"] ) end
	if modules [ n ]["dev"] ~= nil then text_module_dev:setText ( "Dev : " .. modules [ n ]["dev"] ) end
	if modules [ n ]["desc"] ~= nil then text_module_desc:setText ( modules [ n ]["desc"] ) end
	if modules [ n ]["version"] ~= nil then text_module_ver:setText ( "Ver : " .. modules [ n ]["version"] ) end

	btnct = 0
	if modules [ n ]["home"] ~= nil then
		btnct = btnct + 1
		x = 605
		y = 159 + (39*btnct)
		button_home:setPosition( xcore.x2dpoint(x, y) )
		button_home:setVisible( true )
	end
	if modules [ n ]["readme"] ~= nil then
		btnct = btnct + 1
		x = 605
		y = 159 + (39*btnct)
		button_readme:setPosition( xcore.x2dpoint(x, y) )
		button_readme:setVisible( true )
	end

	if modules [ n ]["cat"] == "source" then
		btnct = btnct + 1
		x = 605
		y = 159 + (39*btnct)
		button_view_source:setPosition( xcore.x2dpoint(x, y) )	
		button_view_source:setVisible( true )
	end
	
	module_texture = sim:getTexture( "modules/".. modules [ n ]["file"] .. "/" .. modules [ n ]["file"] .. ".jpg" )
	if module_texture ~= nil then image_module:setImage(module_texture) end
end

function listdirs(dir)
	assert(dir and dir ~= "", "directory parameter is missing or empty")
	if string.sub(dir, -1) == "/" then
		dir=string.sub(dir, 1, -2)
	end
	local diriters = {lfs.dir(dir)}
	local dirs = {dir}
	return function()
	repeat
		local entry = diriters[#diriters]()
		if entry then 
			if entry ~= "." and entry ~= ".." then 
				local filename = table.concat(dirs, "/").."/"..entry
				local attr = lfs.attributes(filename)
				if attr.mode == "directory" then 
					return filename, attr
				end
			end
		else
			table.remove(dirs)
			table.remove(diriters)
		end
	until
		#diriters==0 
	end
end

function listModules()
	for filename, attr in listdirs("modules/") do
		-- print(attr.mode, filename)
		fn=string.sub(filename, 9, -1)
		-- print ( "load : " .. filename .. "/" .. fn .. ".info")
		name = nil
		description = nil
		version = nil
		core = nil
		developer = nil
		licence = nil
		cat = nil
		readme = nil
		home = nil
		core = nil		

		x = loadfile ( filename .. "/" .. fn .. ".info" )
		if x ~= nil then
			x()
			module_count = module_count + 1
			modules [ module_count ] = {}
			modules [ module_count ]["file"] = fn 
			if module ~= nil then modules [ module_count ]["module"] = module end
			if description ~= nil then modules [ module_count ]["desc"] = description end
			if version ~= nil then modules [ module_count ]["version"] = version end
			if core ~= nil then modules [ module_count ]["code"] = core end
			if developer ~= nil then modules [ module_count ]["dev"] = developer end
			if licence ~= nil then modules [ module_count ]["li"] = licence	end
			if cat ~= nil then modules [ module_count ]["cat"] = cat end
			if home ~= nil then modules [ module_count ]["home"] = home end
			if readme ~= nil then modules [ module_count ]["readme"] = readme end
			if core ~= nil then	modules [ module_count ]["core"] = core	end
		else
			-- print("load failed for file " .. filename .. "/" .. fn .. ".info" )
		end
	end
end

-- end of file