-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- actions.lua

actions = { ID = 0 }

-- print "[actions]"

-- creation
function actions:new (o)
	-- print "[actions] new actions"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	-- what about gui text elements?

	width = 128
	height = 20
	x = screen_width - width - 40
	y = 100
	
	-- listbox_abilities = sim:addListbox( 2203, true, xcore.x2drect(x+10, y, x+width-50, y+180 ) )
	actions_window = sim:addWindow( 200, xcore.x2drect(x, y, x+width, y+180), "Actions")
	actions_window:setTitleBarVisible( false )
	
	x = 0
	y = 0
	button_attack = sim:addButton( 202, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Attack" )
	button_attack:setParent( actions_window )
	button_attack:setImage( button_texture )
	button_attack:setPressedImage( button_pressed_texture )	
	
	y = y+btn_h
	button_move = sim:addButton( 203, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Move" )
	button_move:setParent( actions_window )	
	button_move:setImage( button_texture )
	button_move:setPressedImage( button_pressed_texture )

	y = y+btn_h
	button_special = sim:addButton( 204, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Special" )
	button_special:setParent( actions_window )	
	button_special:setImage( button_texture )
	button_special:setPressedImage( button_pressed_texture )

	y = y+btn_h
	button_item = sim:addButton( 205, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Items" )
	button_item:setParent( actions_window )	
	button_item:setImage( button_texture )
	button_item:setPressedImage( button_pressed_texture )

	y = y+btn_h
	button_view = sim:addButton( 206, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "View" )
	button_view:setParent( actions_window )	
	button_view:setImage( button_texture )
	button_view:setPressedImage( button_pressed_texture )

	y = y+btn_h
	button_wait = sim:addButton( 207, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Wait" )
	button_wait:setParent( actions_window )	
	button_wait:setImage( button_texture )
	button_wait:setPressedImage( button_pressed_texture )

	sim:bindGUI ( "button_attack_pressed", 202, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_move_pressed", 203, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_special_pressed", 204, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_item_pressed", 205, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_view_pressed", 206, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_wait_pressed", 207, xcore.XGUI_BUTTON_CLICKED )
	
	self:hide()
	-- print "[actions] new actions"
	return o
end

function actions:hide()
	-- print "[actions] hide"
	actions_window:setVisible( false )
end

function actions:show()
	-- print "[actions] show"
	actions_window:setVisible( true )
	-- print "[actions] /show"
end

function actions:destroy()
	-- print "[actions] destroy"
	button_attack:destroy()
	button_move:destroy()
	-- etc
	
	actions_window:destroy()
end

-- end of file