-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- camera.lua

camera = { ID = 0 }


-- creation
function camera:new (o)
	-- print "[camera] new camera"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	o.ID       = 0
	o.owner_ID  = 0
	o.type  = 0
	o.valid  = 0
	o.position = xcore.x3dpoint( 0, 0, 0 )
	o.rotation = xcore.x3dpoint( 0, 0, 0 )

	o.cam = sim:addCamera ( 0, xcore.CAMERA_STATIC, -100,50,0, 100,0,0)

	o.cam:setFOV( 45 * 3.14159265 / 180 )
	o.cam:setAspectRatio( 16/9 )
	o.cam:setFarValue( 2500 )
	
	-- o.cam:setOrthoMode( screen_width, screen_height, 0, 2500 )

	PI = 3.1415
	o.radius = 100
	o.alpha = 45
	o.theta = 180
	o.rotate = 0

	o.old_radius = 600
	o.old_alpha = 10
	o.old_theta = 180

	mousex = 0
	mousey = 0
	
	cam_facing = FACING_TYPE_NORTH

	return o
end

function camera:reset()
	-- print "[camera] reset"
	self.cam:setPosition( xcore.x3dpoint( 0, 0, 0 ) )
	self.cam:setTarget( xcore.x3dpoint( 1, 0, 1  ) )end

function camera:update()
	-- print "[camera] update"
	
	cam_active = 1
	if cam_active == 1 then
	
		spd = 0.001* cam_speed
		-- print("spd" .. spd)
		if cam_type == 0 then
			yedge = 10
			if mousey < yedge then self.alpha = self.alpha + spd end
			if mousey > screen_height - yedge then self.alpha = self.alpha - spd end
			
			xedge = 10
			if mousex < xedge then self.theta = self.theta + spd end
			if mousex > screen_width - xedge  then self.theta = self.theta - spd end
		else
			if self.rotate == 1 then
				if mousey < self.center_y - 20 then self.alpha = self.alpha + spd end
				if mousey > self.center_y + 20 then self.alpha = self.alpha - spd end
				
				if mousex < self.center_x - 20 then self.theta = self.theta + spd end
				if mousex > self.center_x +  20 then self.theta = self.theta - spd end
			end
			-- only rotate when space or m3 is down
		end

		-- theta = theta - 0.1
		if self.theta < 0 then
			self.theta =  360 + self.theta
		end
		if self.theta > 360 then
			self.theta = self.theta - 360
		end


		if self.theta > 45 and self.theta <= 135 then
			cam_facing = FACING_TYPE_NORTH
		elseif self.theta > 135 and self.theta <= 225 then
			cam_facing = FACING_TYPE_WEST
		elseif self.theta > 225 and self.theta <= 315 then
			cam_facing = FACING_TYPE_SOUTH
		else
			cam_facing = FACING_TYPE_EAST
		end	
		
		-- alpha = alpha + 0.1
		if self.alpha < 20 then
			self.alpha = 20
		end
		if self.alpha > 80 then
			self.alpha = 80
		end

		if self.radius < 50 then self.radius = 50 end
		if self.radius > 1000 then self.radius = 1000 end

		local x = self.radius*math.cos(self.alpha*PI/180)*math.cos(self.theta*PI/180)
		local y = self.radius*math.sin(self.alpha*PI/180)
		local z = self.radius*math.cos(self.alpha*PI/180)*math.sin(self.theta*PI/180)
		local pos = xcore.x3dpoint(x, y, z)
		
		-- local character_pos = characters[ active_character_index ]:getPosition()
		if cam_target == nil then cam_target = xcore.x3dpoint( 0, 0, 0) end

		tmp = xcore.x3dpoint( cam_target.X*tile_size, 0, cam_target.Y*tile_size )

		pos.X = pos.X + tmp.X
		pos.Y = pos.Y + tmp.Y
		pos.Z = pos.Z + tmp.Z

		self.cam:setPosition( pos )
		self.cam:setTarget( tmp  )
	
	end


	-- print "[camera] /update"
end

-- eof