-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- creator.lua
-- character creator...

creator = state:new()

-- print "[creator]"

-- creation
function creator:new (o)
	-- print "[creator] new creator"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	self.sid = 0
	self.step = 1

	-- substates
	-- list   = 1
	-- add    = 2
	-- edit   = 3
	-- delete = 4

	--
	-- list
	--

	width = 250
	height = 290
	-- unit list table
	x = screen_width/2-200
	y = screen_height/2-140

	image_background_creator = sim:addImage( 0, texture_background_512x512, xcore.x2dpoint(x, y),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )	
	x = x + 4
	y = y + 4
	table_creator_roster = sim:addTable( 1299, true, xcore.x2drect( x+0, y+0, x+width, y+height ) )
	-- table_creator_roster:setParent( unitlist_window )
	table_creator_roster:addColumn( "Name       ", 1 )
	table_creator_roster:addColumn( "Class    ", 2 )		
	table_creator_roster:addColumn( "Lv.", 3 )

	btn_w = 128
	btn_h = 30
	-- add some buttons
	x = screen_width/2+80
	y = screen_height/2-140
	button_creator_add = sim:addButton( 751, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Add" )
	button_creator_add:setVisible( false )
	button_creator_add:setImage( button_texture )
	button_creator_add:setPressedImage( button_pressed_texture )
	-- y = y + btn_h + 20
	-- button_creator_edit = sim:addButton( 752, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Edit" )
	-- button_creator_edit:setVisible( false )
	-- button_creator_edit:setImage( button_texture )
	-- button_creator_edit:setPressedImage( button_pressed_texture )	
	y = y + btn_h + 20
	button_creator_delete = sim:addButton( 753, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Delete" )
	button_creator_delete:setVisible( false )
	button_creator_delete:setImage( button_texture )
	button_creator_delete:setPressedImage( button_pressed_texture )

	--
	-- add
	--	
	btn_w = 20
	btn_h = 30	
	
	x = screen_width/2-250
	y = screen_height/2-80
	-- thumbnail
	texture_creator_thumbnail = sim:getTexture( path .. "resources/interface/icon_.png" )
	image_background_icon = sim:addImage( 0, texture_background_icon, xcore.x2dpoint(x, y),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	image_creator_thumbnail = sim:addImage( 0, texture_creator_thumbnail, xcore.x2dpoint(x+4, y+8),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )

	x= x-36
	y = y-32
	button_creator_next_class = sim:addButton( 756, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "" )
	button_creator_next_class:setImage( button_left_texture )
	button_creator_next_class:setPressedImage( button_left_pressed_texture )	
	x = x + btn_w
	y = y + 4
	editbox_creator_name = sim:addEditbox( 30,  xcore.x2drect( x,y,x+100,y+20 ) )
	editbox_creator_name:setText("Name")
	-- editbox_creator_names:setAlignment( 2, 0 )
	y = y - 4
	x = x + 100
	button_creator_back_class = sim:addButton( 757, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "" )
	button_creator_back_class:setImage( button_right_texture )
	button_creator_back_class:setPressedImage( button_right_pressed_texture )

	-- class desc
	width = 400
	height = 200
	x = screen_width/2-120
	y = screen_height/2-100
	text_creator = sim:addText( 0, "Fighter\n\nThe fighter is the main tank of your party. Able to take hits better then any other class, a fighter is best served in the center of the battle.\n\nCost: 100 Gold ", x, y, x+width, y+height)
	-- text_creator:setAlignment( 2, 0 )

	btn_w = 128
	btn_h = 30
	-- add some buttons
	x = screen_width/2-btn_w-10
	y = y + 220
	button_creator_cancel = sim:addButton( 754, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Cancel" )
	button_creator_cancel:setVisible( false )
	button_creator_cancel:setImage( button_texture )
	button_creator_cancel:setPressedImage( button_pressed_texture )
	x = x + btn_w + 20
	button_creator_create = sim:addButton( 755, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Create" )
	button_creator_create:setVisible( false )
	button_creator_create:setImage( button_texture )
	button_creator_create:setPressedImage( button_pressed_texture )

	--
	-- Delete
	--
	
	-- warning text
	width = 400
	height = 200
	x = screen_width/2-150
	y = screen_height/2-120
	text_creator_delete = sim:addText( 0, "are you sure you wish to delete this character? action can not be undone.", x, y, x+width, y+height)
	-- text_creator_delete:setAlignment( 2, 0 )
	text_creator_delete:setVisible( false )
	
	btn_w = 128
	btn_h = 30
	-- add some buttons
	x = screen_width/2-btn_w-10
	y = y + 220
	button_creator_no = sim:addButton( 758, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "no" )
	button_creator_no:setVisible( false )
	button_creator_no:setImage( button_texture )
	button_creator_no:setPressedImage( button_pressed_texture )
	x = x + btn_w + 20
	button_creator_yes = sim:addButton( 759, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "yes" )
	button_creator_yes:setVisible( false )
	button_creator_yes:setImage( button_texture )
	button_creator_yes:setPressedImage( button_pressed_texture )

	-- bind events to actions.
	sim:bindGUI ( "button_creator_add_pressed", 751, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_creator_edit_pressed", 752, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_creator_delete_pressed", 753, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_creator_cancel_pressed", 754, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_creator_create_pressed", 755, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_creator_next_class_pressed", 756, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_creator_back_class_pressed", 757, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_creator_no_pressed", 758, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_creator_yes_pressed", 759, xcore.XGUI_BUTTON_CLICKED )

	self:hide()
	return o
end

function creator:setStep( n )
	self:hide()
	self:getClasses()

	self.step = n
	if n == 1 then
		-- print "[creator] show party roster"
		text_title:setVisible( true )
		button_creator_add:setVisible( true )
		-- button_creator_edit:setVisible( true )
		button_creator_delete:setVisible( true )
		table_creator_roster:setVisible( true )
		image_background_creator:setVisible( true )
		self:updateGroup()
		text_title:setVisible( true )
		text_title:setText( "Party Roster" )
		image_background_title:setVisible( true )

	elseif n == 2 then
		-- print "[creator] add mob"
		image_creator_thumbnail:setVisible( true )
		button_creator_next_class:setVisible( true )
		button_creator_back_class:setVisible( true )
		editbox_creator_name:setVisible( true )
		image_background_icon:setVisible( true )
		text_creator:setVisible( true )
		button_creator_cancel:setVisible( true )
		button_creator_create:setVisible( true )
		text_title:setVisible( true )
		text_title:setText( "Create Character" )
		image_background_title:setVisible( true )
	
		self:updateClass()
	elseif n == 3 then
		print "[creator] edit mob"

	elseif n == 4 then
		print "[creator] delete mob"
		text_creator_delete:setVisible( true )
		button_creator_yes:setVisible( true )
		button_creator_no:setVisible( true )
	end
end

-- called on creator enter
function creator:show ()
	-- print "[creator] show creator"
	self:setStep( 1 )
end

-- called on creator exit
function creator:hide ()
	-- print "[creator] hide creator"
	text_title:setVisible( false )
	button_creator_add:setVisible( false )
	-- button_creator_edit:setVisible( false )
	button_creator_delete:setVisible( false )
	table_creator_roster:setVisible( false )

	image_creator_thumbnail:setVisible( false )
	button_creator_next_class:setVisible( false )
	button_creator_back_class:setVisible( false )
	editbox_creator_name:setVisible( false )
	image_background_icon:setVisible( false )
	button_creator_cancel:setVisible( false )
	button_creator_create:setVisible( false )
	text_creator:setVisible( false )

	text_creator_delete:setVisible( false )
	button_creator_yes:setVisible( false )
	button_creator_no:setVisible( false )

	image_background_creator:setVisible( false )
	
	text_title:setVisible( false )
	text_title:setText( "" )
	image_background_title:setVisible( false )
end

function creator:addMob()
	-- print("[creator] addMob" )
	-- check cash first
	if local_user.gold >= 100 then
		if local_user.party_count < map_party then
		-- add a new user mob to the database
		statement = 			 " INSERT INTO table_characters "
		statement = statement .. " ( character_name, character_owner_id, character_class, character_level, character_hp, character_sp ) "
		statement = statement .. " VALUES ( '" .. editbox_creator_name:getText()  .. "', 1, " .. self.classes[ self.current_class ][ 1 ] .. ", 1, "
		statement = statement .. self.classes[ self.current_class ][ 3 ] .. ", " .. self.classes[ self.current_class ][ 4 ]  .. " )"
		sql:exe( statement )

		local_user.gold = local_user.gold - 100 * tonumber( self.classes[ self.current_class ][ 6 ] ) 
		local_user:save()
		else
			print("[creator] max party count reached")
		end
	else
		print("[creator] not enough gold")
	end
end

function creator:deleteMob()
	-- print("[creator] deleteMob")
	if table_creator_roster:getSelected() ~= -1 then
		statement = 			 " DELETE FROM table_characters "
		statement = statement .. " WHERE character_id = " .. tonumber( self.character_ids[ table_creator_roster:getSelected() ] )
		-- print( statement )
		sql:exe( statement )
	else
		print("[creator] error, no mob selected")
	end
end

function creator:changeClass( n )
	-- print("[creator] changeClass")
	self.current_class = self.current_class + n
	if self.current_class > table.getn( self.classes ) then
		self.current_class = 0
	elseif self.current_class < 0 then
		self.current_class = table.getn( self.classes )
	end
	self:updateClass()
end

function creator:updateGroup() -- update group
	-- print("\n[creator] updateGroup")
	table_creator_roster:clear()
	table_creator_roster:addColumn( "Name       ", 1 )
	table_creator_roster:addColumn( "Class  ", 2 )		
	table_creator_roster:addColumn( "Lv.", 3 )

	self.character_ids = {}
	
	if self.group_id ~= -1 then
		statement =             " SELECT character_id, character_name, character_class, character_level, character_status, class_name, character_state "
		statement = statement .." FROM table_characters "
		statement = statement .." LEFT JOIN table_classes ON class_id = character_class "
		statement = statement .." WHERE character_owner_id = 1 "
		-- print( statement )
		local q = sql:exe( statement )

		if q ~= nil then
			-- print ("returned " .. q:getRowCount() .. " rows ")		
			for i = 0, q:getRowCount()-1 do
				local n = i*q:getHeadCount()
				table_creator_roster:addRow( i+1 )
				-- print("character_id : " .. 		q:getData( n+0 ) )
				-- print("character_name : " .. 		q:getData( n+1 ) )
				-- print("character_class : " .. 		q:getData( n+2 ) )
				-- print("character_level : " .. 		q:getData( n+3 ) )
				self.character_ids[ i ] = q:getData( n+0 )
				if q:getData( n+1 ) ~= nil then table_creator_roster:setCellText ( i, 0, q:getData( n+1 ) ) end	
				if q:getData( n+5 ) ~= nil then table_creator_roster:setCellText ( i, 1, q:getData( n+5 ) ) end
				if q:getData( n+3 ) ~= nil then table_creator_roster:setCellText ( i, 2, q:getData( n+3 ) ) end
				if tonumber( q:getData( n+6 ) ) == STATE_DOWN then table_creator_roster:setCellText ( i, 1, "Unconscious" ) end
			end	
		end
		sql:removeResult( q )		
	end

	-- update group roster table
	-- for n = 0, table.getn( game_map.mobs )-1 do
		-- print("n:" .. n)
		-- print("game_map.mobs[ n ].name:" .. game_map.mobs[ n+1 ].name)
	-- 	if game_map.mobs[ n+1 ].owner_id == 1 then
	-- 		table_unit_list:addRow( n )
	-- 		table_unit_list:setCellText ( n, 0, game_map.mobs[ n+1 ].name )
	-- 		table_unit_list:setCellText ( n, 1, game_map.mobs[ n+1 ].class_name )
	-- 		table_unit_list:setCellText ( n, 2, game_map.mobs[ n+1 ].level )
	-- 	end
	-- end
end

function creator:updateClass() -- update group
	-- print("[creator] mob " .. i ..", class : " .. groupmembers[ i ] )
	editbox_creator_name:setText( self.classes[ self.current_class ][ 2 ] )
	image_creator_thumbnail:setImage( sim:getTexture( path .. "resources/sprites/icon_" .. self.classes[ self.current_class ][ 7 ] .. ".png" ) )
	text_creator:setText( self.classes[ self.current_class ][ 2 ] .. " \nCost : " .. 100 * tonumber( self.classes[ self.current_class ][ 6 ] ) .. " Gold\n\n" .. self.classes[ self.current_class ][ 5 ] )
end

function creator:getClasses ()
	-- print("[creator] getClasses")
	self.classes = {}
	self.current_class = 0

	statement = 			 " SELECT class_id, class_name, stat_hp, stat_sp, class_desc, class_tier, class_graphic "
	statement = statement .. " FROM table_classes LEFT JOIN table_stats on stat_id = class_stat "
	statement = statement .. " WHERE class_type = 0 AND class_tier <= " .. local_user.sequence
	statement = statement .. " ORDER BY class_tier ASC "
	
	-- and class_tier > user.sequence
	
	local q = sql:exe( statement )
	if q == nil then return end

	-- print ("returned " .. q:getRowCount() .. " rows ")
	for i = 0, q:getRowCount()-1 do
		local n = i*q:getHeadCount()
		-- print("class id : " .. 		q:getData( n+0 ) )

		self.classes[ i ] = {}
		self.classes[ i ][ 1 ] = q:getData( n+0 )
		self.classes[ i ][ 2 ] = q:getData( n+1 )
		self.classes[ i ][ 3 ] = q:getData( n+2 )
		self.classes[ i ][ 4 ] = q:getData( n+3 )
		self.classes[ i ][ 5 ] = q:getData( n+4 )
		self.classes[ i ][ 6 ] = q:getData( n+5 )
		self.classes[ i ][ 7 ] = q:getData( n+6 )		
	end

	sql:removeResult(q)
end


-- called when changing creator
function creator:transition ( i ) -- transition to creator v
end

-- eof