-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- edit_encounters.lua

edit_encounters = { ID = 0 }

-- creation
function edit_encounters:new (o)
	-- print "[edit_encounters] new edit_encounters"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	btn_w = 60
	btn_h = 30

	--
	-- list window
	--
	x = 10
	y = 60
	window_edit_encounters_list = sim:addWindow( 1000, xcore.x2drect(x, y, x+128, y+256+60), "Encounter List")
	window_edit_encounters_list:setTitleBarVisible( false )		
	image_background_edit_list = sim:addImage( 0, texture_background_128x256, xcore.x2dpoint(0, 0),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	image_background_edit_list:setParent( window_edit_encounters_list )

	-- list
	width = 118	
	x = 5
	y = 10
	height = 236
	listbox_edit_encounters = sim:addListbox( 1010, true, xcore.x2drect( x,y,x+width,y+height ) )
	listbox_edit_encounters:setParent( window_edit_encounters_list )
	listbox_edit_encounters:addItem("test")

	x = 0
	y = 256

	-- add some buttons
	button_edit_encounters_edit = sim:addButton( 3002, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Edit" )
	button_edit_encounters_edit:setParent( window_edit_encounters_list )
	button_edit_encounters_edit:setImage( button_small_texture )
	button_edit_encounters_edit:setPressedImage( button_small_pressed_texture )
	
	x = x+ btn_w + 6
	button_edit_encounters_delete = sim:addButton( 3003, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Delete" )
	button_edit_encounters_delete:setParent( window_edit_encounters_list )
	button_edit_encounters_delete:setImage( button_small_texture )
	button_edit_encounters_delete:setPressedImage( button_small_pressed_texture )

	x = 0
	y = y + 30
	btn_w = 128
	button_edit_encounters_add = sim:addButton( 3001, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Add" )
	button_edit_encounters_add:setParent( window_edit_encounters_list )
	button_edit_encounters_add:setImage( button_texture )
	button_edit_encounters_add:setPressedImage( button_pressed_texture )	
	
	sim:bindGUI ( "button_edit_encounters_add_pressed", 3001, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_encounters_edit_pressed", 3002, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_encounters_delete_pressed", 3003, xcore.XGUI_BUTTON_CLICKED )

	--
	-- data window
	--
	x = 260
	y = 60
	window_edit_encounters_data = sim:addWindow( 1000, xcore.x2drect(x, y, x+380, y+450), "Encounter Data")

	y = 30
	x = 20
	-- add text input for name
	label_edit_encounters_name = sim:addText( 0, "Name", x, y, x+100, y+20 )
	label_edit_encounters_name:setParent( window_edit_encounters_data )
	x = x+110
	textfield_edit_encounters_name = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_encounters_name:setParent( window_edit_encounters_data )

	y = y + 30
	x = 20	
	-- add text input for stage
	label_edit_encounters_seq = sim:addText( 0, "Sequence", x, y, x+100, y+20 )
	label_edit_encounters_seq:setParent( window_edit_encounters_data )
	x = x+110
	textfield_edit_encounters_seq = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_encounters_seq:setParent( window_edit_encounters_data )
	
	y = y + 30
	x = 20
	-- add numeric inputs for att and def
	label_edit_encounters_level_min = sim:addText( 0, "Lv. Min", x, y, x+80, y+20 )
	label_edit_encounters_level_min:setParent( window_edit_encounters_data )
	x = x+110
	textfield_edit_encounters_level_min = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_encounters_level_min:setParent( window_edit_encounters_data )
	x = x + 50
	label_edit_encounters_level_max = sim:addText( 0, "Lv. Max", x, y, x+80, y+20 )
	label_edit_encounters_level_max:setParent( window_edit_encounters_data )
	x = x+110
	textfield_edit_encounters_level_max = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_encounters_level_max:setParent( window_edit_encounters_data )

	-- encounter group member table
	x =	20
	y =	y + 30
	width = 330
	height = 200	
	table_edit_group_members = sim:addTable( 12, true, xcore.x2drect( x+0, y+0, x+width, y+height ) )
	table_edit_group_members:setParent( window_edit_encounters_data )
	table_edit_group_members:addColumn( "ID", 1 )	
	table_edit_group_members:addColumn( "Class        ", 2 )
	table_edit_group_members:addColumn( "Min#", 3 )	
	table_edit_group_members:addColumn( "Max#", 4 )		
	table_edit_group_members:addColumn( "%%", 5 )

	x = 20
	y = 300
	-- button for add drop
	button_edit_member_add = sim:addButton( 3013, xcore.x2drect( x, y, x+40, y+20 ), "Add" )
	button_edit_member_add:setParent( window_edit_encounters_data )	
	x = x+50
	-- combo box for protos
	combobox_edit_member_class = sim:addCombobox( 11, xcore.x2drect(x, y, x+130, y+20 ) )
	combobox_edit_member_class:setParent( window_edit_encounters_data )
	combobox_edit_member_class:addItem("Test Class")
	x = x+140
	-- text field for qty
	textfield_edit_member_min = sim:addEditbox( 320,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_member_min:setParent( window_edit_encounters_data )		
	x = x+50
	-- text field for chance
	textfield_edit_member_max = sim:addEditbox( 320,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_member_max:setParent( window_edit_encounters_data )		
	x = x+50
	-- text field for chance
	textfield_edit_member_chance = sim:addEditbox( 320,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_member_chance:setParent( window_edit_encounters_data )		

	y = y +30
	btn_w = 160
	x = 120
	-- button for delete drop
	button_edit_member_remove = sim:addButton( 3012, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Remove" )
	button_edit_member_remove:setParent( window_edit_encounters_data )	

	y = y +30
	btn_w = 160
	x = 120
	button_edit_encounters_save = sim:addButton( 3011, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Save" )
	button_edit_encounters_save:setParent( window_edit_encounters_data )
	button_edit_encounters_save:setImage( button_texture )
	button_edit_encounters_save:setPressedImage( button_pressed_texture )
	
	sim:bindGUI ( "button_edit_encounters_save_pressed", 3011, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_member_remove_pressed", 3012, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_member_add_pressed", 3013, xcore.XGUI_BUTTON_CLICKED )

	stat_id = -1
	self.mode = 1
	self.group_id = -1

	self:hide()
	return o
end

function edit_encounters:hide()
	-- print "[edit_encounters] hide"
	window_edit_encounters_list:setVisible( false )
	window_edit_encounters_data:setVisible( false )
end

function edit_encounters:show()
	-- print "[edit_encounters] show"
	self:updateGroupList()

	window_edit_encounters_list:setVisible( true )
	-- print "[edit_encounters] /show"
end

function edit_encounters:destroy()
	-- print "[edit_encounters] destroy"
	window_edit_encounters_list:destroy()
end

function edit_encounters:input()
	if sim:isGUI( "button_edit_encounters_add_pressed" ) then
		-- print("button_edit_encounters_add_pressed")
		window_edit_encounters_data:setVisible( true )
		self:showAdd()
	end
	if sim:isGUI( "button_edit_encounters_edit_pressed" ) then
		-- print("button_edit_encounters_edit_pressed")
		window_edit_encounters_data:setVisible( true )
		self:showEdit()
	end
	if sim:isGUI( "button_edit_encounters_delete_pressed" ) then
		-- print("button_edit_encounters_delete_pressed")
		self:delete()
	end	
	if sim:isGUI( "button_edit_encounters_save_pressed" ) then
		-- print("button_edit_encounters_save_pressed")
		self:save()
	end
	if sim:isGUI( "button_edit_member_remove_pressed" ) then
		print("button_edit_member_remove_pressed")
		self:removeMember()
	end
	if sim:isGUI( "button_edit_member_add_pressed" ) then
		-- print("button_edit_member_add_pressed")
		self:addMember()
	end
end

function edit_encounters:removeMember()
	print("[edit_encounters] removeMember")
	if self.group_id ~= -1 and table_edit_group_members:getSelected() ~= -1 then
		statement = " DELETE FROM table_encounters WHERE encounter_id = "  .. table_edit_group_members:getCellText ( table_edit_group_members:getSelected(), 0  )
		print( statement )
		sql:exe( statement )
	end
	self:loadMembers()
end

function edit_encounters:addMember()
	print("[edit_encounters] addMember")
	print("mob name: " .. combobox_edit_member_class:getItem( combobox_edit_member_class:getSelected() ) )
	print("count: " .. textfield_edit_member_min:getText() .. " - " .. textfield_edit_member_max:getText() )
	print("%: " .. textfield_edit_member_chance:getText() )
	print("group_id: " .. self.group_id )

	query = "SELECT class_id FROM table_classes WHERE class_name = '" ..  combobox_edit_member_class:getItem( combobox_edit_member_class:getSelected() ) .. "'"
	local q = sql:exe( query )
	if q ~= nil then
		if q:getData( 0 ) ~= nil then
			-- print ("[edit_encounters] name : " .. q:getData( 0 ) )
			mob_id = q:getData( 0 )
		end
	end

	if mob_id ~= nil then
		-- encounter_mob_id, class_name, encounter_mobs_min, encounter_mobs_max, encounter_chance, encounter_group_id
		query = " INSERT INTO table_encounters "
		query = query .. " ( encounter_group_id, encounter_mob_id, encounter_mobs_min, encounter_mobs_max, encounter_chance )"
		query = query .. "VALUES ( "
		query = query .. "'".. self.group_id .. "', "
		query = query .. "'".. mob_id .. "', "
		query = query .. "'".. textfield_edit_member_min:getText() .. "', "
		query = query .. "'".. textfield_edit_member_max:getText() .. "', "
		query = query .. "'".. textfield_edit_member_chance:getText() .. "' "	
		query = query .. " )"
		print( query )
		sql:exe( query )
	end
	self:loadMembers()
end

function edit_encounters:save()
	print("[edit_encounters] save")
	-- item_name, item_type, item_class, item_effect, item_graphic, item_stat, stat_attack, stat_defense, stat_speed, stat_range, stat_damage, stat_drain, stat_sp, stat_hp

	if self.mode == 1 then
		-- print("[edit_encounters] INSERT")

		query = " INSERT INTO table_groups "
		query = query .. " ( group_name, group_level_min, group_level_max, group_sequence )"
		query = query .. "VALUES ( "
		query = query .. "'".. textfield_edit_encounters_name:getText() .. "', "
		query = query .. "'".. textfield_edit_encounters_level_min:getText() .. "', "
		query = query .. "'".. textfield_edit_encounters_level_max:getText() .. "', "
		query = query .. "'".. textfield_edit_encounters_seq:getText() .. "' "		
		query = query .. " )"

		-- print( query )
		sql:exe( query )
	else
		-- print("[edit_encounters] UPDATE")

		query = "UPDATE table_groups SET "
		query = query .. " group_name = '" .. textfield_edit_encounters_name:getText() .. "', "
		query = query .. " group_level_min = '" .. textfield_edit_encounters_level_min:getText() .. "', "
		query = query .. " group_level_max = '" .. textfield_edit_encounters_level_max:getText() .. "', "
		query = query .. " group_sequence = '" .. textfield_edit_encounters_seq:getText() .. "' "

		query = query .. " WHERE group_id = " .. self.group_id
		-- print( query )
		sql:exe( query )
	end
	self:updateGroupList()
end

function edit_encounters:delete()
	if listbox_edit_encounters:getSelected() == -1 then return nil end
	n = listbox_edit_encounters:getItem( listbox_edit_encounters:getSelected() )
	-- print("[edit_encounters] delete encounter group : " .. n)

	query = "DELETE FROM table_groups WHERE group_name = '" ..  n .. "'"
	local q = sql:exe( query )

	self:updateGroupList()
end

function edit_encounters:showAdd()
	self.mode = 1
	-- print "[edit_encounters] showAdd"
	-- show confirmation
	textfield_edit_encounters_name:setText("")
	textfield_edit_encounters_level_min:setText( "0" )
	textfield_edit_encounters_level_max:setText( "0" )
	textfield_edit_encounters_seq:setText( "0" )

	button_edit_member_add:setVisible(false)
	combobox_edit_member_class:setVisible(false)
	textfield_edit_member_min:setVisible(false)
	textfield_edit_member_max:setVisible(false)
	textfield_edit_member_chance:setVisible(false)
	table_edit_group_members:setVisible(false)
	button_edit_member_remove:setVisible(false)
	self.group_id = -1
end

function edit_encounters:showEdit()
	self.mode = 2
	-- print "[edit_encounters] showEdit"
	-- show confirmation

	n = listbox_edit_encounters:getItem( listbox_edit_encounters:getSelected() )
	-- print("[edit_encounters] edit item : " .. n)
	query = "SELECT group_name, group_level_min, group_level_max, group_id, group_sequence FROM table_groups WHERE group_name = '" ..  n .. "'"
	local q = sql:exe( query )
	if q ~= nil then
		if q:getData( 0 ) ~= nil then
			-- print ("[edit_encounters] name : " .. q:getData( 0 ) )
			textfield_edit_encounters_name:setText( q:getData( 0 ) )
		end
		if q:getData( 1 ) ~= nil then
			-- print ( q:getData( 1 ) )
			textfield_edit_encounters_level_min:setText( q:getData( 1 ) )
		end
		if q:getData( 2 ) ~= nil then
			-- print ( q:getData( 2 ) )
			textfield_edit_encounters_level_max:setText( q:getData( 2 ) )
		end
		self.group_id = tonumber( q:getData( 3 ) )
		if q:getData( 4 ) ~= nil then
			-- print ( q:getData( 2 ) )
			textfield_edit_encounters_seq:setText( q:getData( 4 ) )
		end

		sql:removeResult( q )
	end

	combobox_edit_member_class:setSelected( 0 )
	textfield_edit_member_min:setText( "0" )
	textfield_edit_member_max:setText( "0" )
	textfield_edit_member_chance:setText( "0" )

	button_edit_member_add:setVisible(true)
	combobox_edit_member_class:setVisible(true)
	textfield_edit_member_min:setVisible(true)
	textfield_edit_member_max:setVisible(true)
	textfield_edit_member_chance:setVisible(true)
	table_edit_group_members:setVisible(true)
	button_edit_member_remove:setVisible(true)

	self:loadMembers()
end

function edit_encounters:showDelete()
	-- print "[edit_encounters] showDelete"
	-- show confirmation
end

function edit_encounters:updateGroupList()
	-- print "[edit_encounters] updateGroupList"
	listbox_edit_encounters:clear()
	statement = "SELECT group_name FROM table_groups WHERE 0 = 0 ORDER BY group_sequence ASC, group_level_min ASC"
	local q = sql:exe( statement )
	if q ~= nil then
		for i = 0, q:getRowCount()-1 do
			local n = i*q:getHeadCount()
				listbox_edit_encounters:addItem( q:getData( i ) )
		end
	end
	sql:removeResult( q )
	window_edit_encounters_data:setVisible( false )
end

function edit_encounters:loadMembers()
	print "[state_edit] loadMembers"
	table_edit_group_members:clear()
	table_edit_group_members:addColumn( "ID", 1 )	
	table_edit_group_members:addColumn( "Class        ", 2 )
	table_edit_group_members:addColumn( "Min#", 3 )	
	table_edit_group_members:addColumn( "Max#", 4 )		
	table_edit_group_members:addColumn( "%%", 5 )

	if self.group_id ~= -1 then
		statement =             " SELECT encounter_id, class_name, encounter_mobs_min, encounter_mobs_max, encounter_chance "
		statement = statement .." FROM table_encounters "
		statement = statement .." LEFT JOIN table_classes on class_id = encounter_mob_id "
		statement = statement .." WHERE encounter_group_id = " .. self.group_id
		-- print( statement )
		local q = sql:exe( statement )
		
		if q ~= nil then
			-- print ("returned " .. q:getRowCount() .. " rows ")		
			for i = 0, q:getRowCount()-1 do
				local n = i*q:getHeadCount()
				table_edit_group_members:addRow( i+1 )

				if q:getData( n+0 ) ~= nil then table_edit_group_members:setCellText ( i, 0, q:getData( n+0 ) ) end
				if q:getData( n+1 ) ~= nil then table_edit_group_members:setCellText ( i, 1, q:getData( n+1 ) ) end	
				if q:getData( n+2 ) ~= nil then table_edit_group_members:setCellText ( i, 2, q:getData( n+2 ) ) end
				if q:getData( n+3 ) ~= nil then table_edit_group_members:setCellText ( i, 3, q:getData( n+3 ) ) end
				if q:getData( n+3 ) ~= nil then table_edit_group_members:setCellText ( i, 4, q:getData( n+4 ) ) end				
			end	
		end
		sql:removeResult( q )		
	end

	-- list classes
	combobox_edit_member_class:clear()
	statement = "SELECT class_name FROM table_classes WHERE class_type >=0 "
	local q = sql:exe( statement )
	if q ~= nil then
		for i = 0, q:getRowCount()-1 do
			local n = i*q:getHeadCount()
				combobox_edit_member_class:addItem( q:getData( i ) )
		end
	end
	sql:removeResult( q )
end

-- end of file