-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- selector.lua
-- Stage Select

selector = state:new()

-- print "[selector]"

-- creation
function selector:new (o)
	-- print "[selector] new quest selector"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	self.sid = 0

	width = 350
	height = 250

	x = screen_width/2-200
	y = screen_height/2-140
	text_selector = sim:addText( 0, "selector text", x, y, x+width, y+height)
	-- text_selector:setAlignment( 2, 0 )
	text_selector:setVisible( false )

	--
	-- navigation
	--
	
	s_btn_w = 20
	s_btn_h = 30	
	
	btn_w = 128
	btn_h = 30
	-- add some buttons
	x = screen_width/2- ((btn_w+(s_btn_w*2))/2) -5
	y = y + 220
	-- x = x + btn_w + 20
	button_selector_back = sim:addButton( 711, xcore.x2drect( x, y, x+s_btn_w, y+s_btn_h ), " " )
	button_selector_back:setVisible( false )
	button_selector_back:setImage( button_left_texture )
	button_selector_back:setPressedImage( button_left_pressed_texture )	
	x = x + s_btn_w + 5
	button_selector_start = sim:addButton( 701, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Start" )
	button_selector_start:setVisible( false )
	button_selector_start:setImage( button_texture )
	button_selector_start:setPressedImage( button_pressed_texture )
	x = x + btn_w + 5	
	button_selector_next = sim:addButton( 710, xcore.x2drect( x, y, x+s_btn_w, y+s_btn_h ), " " )
	button_selector_next:setVisible( false )
	button_selector_next:setImage( button_right_texture )
	button_selector_next:setPressedImage( button_right_pressed_texture )


	-- bind events to actions.
	sim:bindGUI ( "button_selector_start_pressed", 701, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_selector_next_pressed", 710, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_selector_back_pressed", 711, xcore.XGUI_BUTTON_CLICKED )
	self:hide()

	self.current_quest = 0
	
	return o
end

function selector:loadQuests()
	-- print("[selector] update")
	self.quests = {}
	if self.group_id ~= -1 then
		statement = "SELECT stage_id, stage_name, stage_type, stage_desc, stage_depth, stage_size, stage_level_min, stage_level_max, stage_sequence, stage_reward FROM table_stages WHERE 0 = 0  ORDER BY stage_sequence ASC "
		-- print( statement )
		local q = sql:exe( statement )
		if q ~= nil then
			-- print ("\n[selector] returned " .. q:getRowCount() .. " rows ")		
			for i = 0, q:getRowCount()-1 do
				local n = i*q:getHeadCount()
				-- print("[selector] stage_id : " .. 		q:getData( n+0 ) )
				-- print("[selector] stage_name : " .. 		q:getData( n+1 ) )
				-- print("stage_type : " .. 		q:getData( n+2 ) )
				-- print("stage_desc : " .. 		q:getData( n+3 ) )
				-- print("stage_depth : " .. 		q:getData( n+4 ) )
				-- print("stage_size : " .. 		q:getData( n+5 ) )
				-- print("stage_level_min : " .. 		q:getData( n+6 ) )
				-- print("stage_level_max : " .. 		q:getData( n+7 ) )
				-- print("stage_sequence : " .. 		q:getData( n+8 ) )

				self.quests[ i ] = {}
				self.quests[ i ]["id"] = 0
				self.quests[ i ]["name"] = 0
				self.quests[ i ]["type"] = 0
				self.quests[ i ]["desc"] = 0
				self.quests[ i ]["depth"] = 0
				self.quests[ i ]["size"] = 0
				self.quests[ i ]["min"] = 0
				self.quests[ i ]["max"] = 0
				self.quests[ i ]["seq"] = 0
				self.quests[ i ]["reward"] = 0
				
				if q:getData( n+0 ) ~= nil then self.quests[ i ]["id"] = tonumber( q:getData( n+0 ) ) end	
				if q:getData( n+1 ) ~= nil then self.quests[ i ]["name"] = q:getData( n+1 ) end	
				if q:getData( n+2 ) ~= nil then self.quests[ i ]["type"] = tonumber( q:getData( n+2 ) ) end	
				if q:getData( n+3 ) ~= nil then self.quests[ i ]["desc"] = q:getData( n+3 ) end	
				if q:getData( n+4 ) ~= nil then self.quests[ i ]["depth"] = tonumber( q:getData( n+4 ) ) end	
				if q:getData( n+5 ) ~= nil then self.quests[ i ]["size"] = tonumber( q:getData( n+5 ) ) end	
				if q:getData( n+6 ) ~= nil then self.quests[ i ]["min"] = tonumber( q:getData( n+6 ) ) end	
				if q:getData( n+7 ) ~= nil then self.quests[ i ]["max"] = tonumber( q:getData( n+7 ) ) end	
				if q:getData( n+8 ) ~= nil then self.quests[ i ]["seq"] = tonumber( q:getData( n+8 ) ) end	
				if q:getData( n+9 ) ~= nil then	self.quests[ i ]["reward"] = tonumber( q:getData( n+9 ) ) end
			end	
		end
		sql:removeResult( q )		
	end
	-- set starting variables.
end

function selector:show()
	-- print "[selector] showMapFeatures"
	button_selector_back:setVisible( true )
	button_selector_next:setVisible( true )
	button_selector_start:setVisible( true )
	text_selector:setVisible( true )

	text_title:setVisible( true )
	text_title:setText( "Select Quest" )
	image_background_title:setVisible( true )
	
	self:loadQuests()
	self.current_quest = local_user.sequence
	self:changeQuest( 0 )
end

function selector:hide()
	button_selector_back:setVisible( false )
	button_selector_next:setVisible( false )
	button_selector_start:setVisible( false )
	text_selector:setVisible( false )	
end

function selector:isUnlocked()
	if self.quests[ self.current_quest ]["seq"] > local_user.sequence then
		return false
	else
		return true
	end
end

function selector:changeQuest( n )
	-- print("[selector] changeQuest")
	self.current_quest = self.current_quest + n
	if self.current_quest > table.getn( self.quests ) then
		self.current_quest = 0
	elseif self.current_quest < 0 then
		self.current_quest = table.getn( self.quests )
	end
	self:update()
end

function selector:update() -- update map
	-- print("[selector] update")
	if self.quests[ self.current_quest ]["seq"] > local_user.sequence then
	 	data = "Quest : LOCKED \n"
	 	text_selector:setText( data )
	else
		-- print("self.current_quest: " .. self.current_quest )
		-- print("name: : " .. self.quests[ self.current_quest ]["name"] )
		
		data = "Quest : " .. self.quests[ self.current_quest ]["name"] .. "\n\n"
		data = data .. " " .. self.quests[ self.current_quest ]["desc"] .. "\n\n"
		-- data = data .. "type : " .. self.quests[ self.current_quest ]["type"] .. "\n"
		-- data = data .. "depth : " .. self.quests[ self.current_quest ]["depth"] .. "\n"
		data = data .. "Reward : " .. self.quests[ self.current_quest ]["reward"] .. " Gold\n\n"
		data = data .. "Levels : " .. self.quests[ self.current_quest ]["min"] .. "-" .. self.quests[ self.current_quest ]["max"] .. "\n"
		
		map_level_min = self.quests[ self.current_quest ]["min"]
		map_level_max = self.quests[ self.current_quest ]["max"]
		map_reward    =  tonumber( self.quests[ self.current_quest ]["reward"] )
		map_size =  self:getMapSize( tonumber( self.quests[ self.current_quest ]["size"] ) )
		map_type = tonumber( self.quests[ self.current_quest ]["type"] )
		map_depth = tonumber( self.quests[ self.current_quest ]["depth"] )	
		map_sequence = tonumber( self.quests[ self.current_quest ]["seq"] )	

		text_selector:setText( data )
	end
end

function selector:getMapSize( n )
	if n > 4 then
		return 32
	elseif n == 3 then
		return 24
	elseif  n == 2 then
		return 18
	else
		return 12
	end
end

-- called when changing selector
function selector:transition ( i ) -- transition to selector v
end

-- eof