-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- specials.lua

specials = { ID = 0 }

-- print "[specials]"

-- creation
function specials:new (o)
	-- print "[specials] new specials"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	width = 128
	height = 256+30
	x = screen_width - width - 40
	y = 300

	-- listbox_abilities = sim:addListbox( 2203, true, xcore.x2drect(x+10, y, x+width-50, y+180 ) )
	specials_window = sim:addWindow( 400, xcore.x2drect(x, y, x+width, y+height), "Abilities")
	specials_window:setTitleBarVisible( false )

	image_background_specials = sim:addImage( 0, texture_background_128x256, xcore.x2dpoint(0, 0),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	image_background_specials:setParent( specials_window )

	width = 118	
	x = 5
	y = 10
	height = 240
	listbox_specials =  sim:addListbox( 0, true, xcore.x2drect(x, y, x+width, y+height) )
	listbox_specials:setParent( specials_window )

	x = 0
	y = 256
	width = 128	
	button_specials_use = sim:addButton( 503, xcore.x2drect( x, y, x+width, y+30 ), "Use Ability" )
	button_specials_use:setParent( specials_window )
	button_specials_use:setImage( button_texture )
	button_specials_use:setPressedImage( button_pressed_texture )

	sim:bindGUI ( "button_specials_use_pressed", 503, xcore.XGUI_BUTTON_CLICKED )	
	
	self:hide()
	-- print "[specials] new specials"
	
	return o
end

function specials:hide()
	-- print "[specials] hide"
	specials_window:setVisible( false )
end

function specials:show()
	-- print "[specials] show"
	specials_window:setVisible( true )
	self:update()
	-- print "[specials] /show"
end

function specials:destroy()
	-- print "[specials] destroy"
	specials_window:destroy()
end

function specials:clear()
	-- print "[specials] clear"
	listbox_specials:clear()
end

function specials:update()
	-- print "[specials] update"
	listbox_specials:clear()
	-- print("[specials] selected mob has : " .. table.getn( game_map.mobs[ selected ].special_abilities ) .. " abilities" )
	for i = 1, table.getn( game_map.mobs[ selected ].special_abilities ) do
		if game_map.mobs[ selected ].level >= game_map.mobs[ selected ].special_abilities[ i ].ability_level then
			listbox_specials:addItem( game_map.mobs[ selected ].special_abilities[ i ].ability_name )
		end
	end
end

-- end of file