-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- state_edit.lua

state_edit = state:new()

-- creation
function state_edit:new (o)
	-- print "[state_edit] new state_edit"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	substate = 0

	x = 170
	y = (screen_height/2 - 256) + 20

	btn_w = 128
	btn_h = 30
	
	x = 10
	y = 10

	button_edit_classes = sim:addButton( 903, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Classes" )
	button_edit_classes:setImage( button_texture )
	button_edit_classes:setPressedImage( button_pressed_texture )	
	x = x+ btn_w + 10
	button_edit_abilities = sim:addButton( 902, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Abilities" )
	button_edit_abilities:setImage( button_texture )
	button_edit_abilities:setPressedImage( button_pressed_texture )	
	x = x+ btn_w + 10
	button_edit_effects = sim:addButton( 909, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Effects" )
	button_edit_effects:setImage( button_texture )
	button_edit_effects:setPressedImage( button_pressed_texture )	
	x = x+ btn_w + 10	
	button_edit_items = sim:addButton( 904, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Items" )
	button_edit_items:setImage( button_texture )
	button_edit_items:setPressedImage( button_pressed_texture )	
	x = x+ btn_w + 10
	button_edit_encounters = sim:addButton( 905, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Encounters" )
	button_edit_encounters:setImage( button_texture )
	button_edit_encounters:setPressedImage( button_pressed_texture )	
	x = x+ btn_w + 10
	button_edit_tiles = sim:addButton( 907, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Tiles" )
	button_edit_tiles:setImage( button_texture )
	button_edit_tiles:setPressedImage( button_pressed_texture )	


	x = 10
	y = 50
	button_edit_dialog = sim:addButton( 908, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Dialog" )
	button_edit_dialog:setImage( button_texture )
	button_edit_dialog:setPressedImage( button_pressed_texture )
	x = x+ btn_w + 10
	button_edit_stages = sim:addButton( 906, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Stages" )
	button_edit_stages:setImage( button_texture )
	button_edit_stages:setPressedImage( button_pressed_texture )	
	x = x+ btn_w + 10	
	button_edit_exit = sim:addButton( 901, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Back" )
	button_edit_exit:setImage( button_texture )
	button_edit_exit:setPressedImage( button_pressed_texture )	

	sim:bindGUI ( "button_edit_exit_pressed", 901, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_abilities_pressed", 902, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_classes_pressed", 903, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_items_pressed", 904, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_encounters_pressed", 905, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_stages_pressed", 906, xcore.XGUI_BUTTON_CLICKED )	
	sim:bindGUI ( "button_edit_tiles_pressed", 907, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_dialog_pressed", 908, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_effects_pressed", 909, xcore.XGUI_BUTTON_CLICKED )

	menu_items = edit_items:new()
	menu_modules = edit_modules:new()
	menu_encounters = edit_encounters:new()
	menu_classes = edit_classes:new()
	menu_abilities = edit_abilities:new()
	menu_tiles = edit_tiles:new()
	menu_stages = edit_stages:new()
	menu_edit_dialog = edit_dialog:new()
	menu_edit_effects = edit_effects:new()
	
	self:hide()
	return o
end

-- called on state_edit enter
function state_edit:enter ()
	-- print "[state_edit] enter state_edit"
	self:show()
	-- menu_text:setText("About")
	
	-- data_text:setText( txt )
	-- print "[state_edit] /enter"
end

-- called on state_edit exit
function state_edit:exit ()
	-- print "[state_edit] exit state_edit"
	self:hide()

end

function state_edit:show ()
	-- print "[state_edit] show"
	button_edit_exit:setVisible( true )
	button_edit_abilities:setVisible( true )
	button_edit_classes:setVisible( true )
	button_edit_items:setVisible( true )
	button_edit_encounters:setVisible( true )
	button_edit_tiles:setVisible( true )
	button_edit_stages:setVisible( true )
	button_edit_dialog:setVisible( true )
	button_edit_effects:setVisible( true )
end

function state_edit:hide ()
	-- print "[state_edit] hide"
	button_edit_exit:setVisible( false )
	button_edit_abilities:setVisible( false )
	button_edit_classes:setVisible( false )
	button_edit_items:setVisible( false )
	button_edit_encounters:setVisible( false )
	button_edit_tiles:setVisible( false )
	button_edit_stages:setVisible( false )
	button_edit_dialog:setVisible( false )
	button_edit_effects:setVisible( false )
	
	menu_tiles:hide()
	menu_items:hide()
	menu_modules:hide()
	menu_encounters:hide()
	menu_classes:hide()
	menu_abilities:hide()
	menu_stages:hide()
	menu_edit_dialog:hide()
	menu_edit_effects:hide()	
end

-- called to advance state_edit
function state_edit:input ()
	-- print ( "[state_edit] input")
	r = ENUM_EDIT
	if sim:isKey( "key_pressed_exit_state" ) then r = ENUM_MENU end
	if sim:isGUI( "button_edit_exit_pressed" ) then return ENUM_MENU end
	if sim:isGUI( "button_edit_abilities_pressed" ) then
		self:hide()
		self:show()		
		menu_abilities:show()
	end
	if sim:isGUI( "button_edit_classes_pressed" ) then
		self:hide()
		self:show()		
		menu_classes:show()
	end
	if sim:isGUI( "button_edit_items_pressed" ) then
		self:hide()
		self:show()	
		menu_items:show()
	end
	if sim:isGUI( "button_edit_encounters_pressed" ) then
		self:hide()
		self:show()
		menu_encounters:show()
	end
	if sim:isGUI( "button_edit_tiles_pressed" ) then
		self:hide()
		self:show()
		menu_tiles:show()
	end
	if sim:isGUI( "button_edit_stages_pressed" ) then
		self:hide()
		self:show()
		menu_stages:show()
	end
	if sim:isGUI( "button_edit_dialog_pressed" ) then
		self:hide()
		self:show()
		menu_edit_dialog:show()
	end
	if sim:isGUI( "button_edit_effects_pressed" ) then
		self:hide()
		self:show()
		menu_edit_effects:show()
	end

	menu_items:input()
	menu_modules:input()
	menu_encounters:input()
	menu_classes:input()
	menu_abilities:input()
	menu_tiles:input()
	menu_stages:input()
	menu_edit_dialog:input()
	edit_effects:input()
	sim:update()
	return r
end

-- called when changing state_edit
function state_edit:transition ( i ) -- transition to state_edit v
	-- print "[state_edit] transition"
end
