-- state_validate object
-- lwi
-- ...

state_validate = state:new()

print "[state_validate]"

-- creation
function state_validate:new (o)
	print "[state_validate] new state_validate"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	self.sid = 0
	self.time = 0

	return o
end

-- called on state_validate enter
function state_validate:enter ()
	print "[state_validate] enter state_validate"
	self.time = 0
end

-- called on state_validate exit
function state_validate:exit ()
	print "[state_validate] exit state_validate"
	
	if alertbox ~= nil then
		alertbox:destroy()
		alertbox = nil
	end

end

-- called to advance state_validate
function state_validate:input ()
	-- print ( "[state_validate] input")
	self.time = self.time + 1
	r = ENUM_VALIDATE -- 1

	sim:update()
	if net:update() ~= 1 then
		print ( "connection lost" )
		if alertbox == nil then
			alertbox = dialogbox:new()
			alertbox:addMessage("Unable to find Server")
			alertbox:addButton("Exit", "dialog_auth_denied")
		end		
	end        -- update network
	
	if sim:isGUI( "dialog_auth_denied" ) then
		print "dialog_auth_denied"
		-- dismiss box
		return ENUM_MENU
	end
	
	
	-- get oldest message out ov que
	packet = net:get()
	
	if packet ~= nil then
		print "[state_validate] packet not null"
		if tonumber( packet:getType() ) == xcore.XPACKET_AUTH then
			print "[state_validate] got auth"
			a = packet:getMessage()

			tmp = string.split( a, ";" )
			print ( a )
			for index,value in pairs( tmp ) do
				print (index, value)
			end
			
			if tmp[1] == "allow" then
				print "[state_validate] auth allowed by server"
				print ( "Local User ID : " .. tmp[2] )
				local_user_id = tmp[2]
				r = ENUM_GAME
			elseif tmp[1] == "denied_invalid" then
				-- print "[state_validate] invalid password"
				if alertbox == nil then
					alertbox = dialogbox:new()
					alertbox:addMessage("Invalid password")
					alertbox:addButton("Exit", "dialog_auth_denied")
				end
			elseif tmp[1] == "denied_in_use" then			
				-- print "[state_validate] user already logged in"
				if alertbox == nil then
					alertbox = dialogbox:new()
					alertbox:addMessage("User already connected")
					alertbox:addButton("Exit", "dialog_auth_denied")
				end
			else
				-- print "[state_validate] auth denied by server"
			end
		else
			-- print ( "[state_validate] unknown packet type: " .. tonumber( packet:getType() ) )
		end

	end

	-- todo : add timeout.

	return r
end

-- called when changing state_validate
function state_validate:transition ( i )
	-- print "[state_validate] transition"
end

