-- xenjine layer 2 network tutorial 2b (chat server)
-- c2008-2009 lukas irwin | sysop [ at ] xhrit.com
-- tutorial_chat_server.module

print "[server] Chat Server Demo"

-- server
function init()
	print "[server] init server"
	-- create net object and init a server
	net = xcore.xnet()
	net:server()

	-- create the sql object and make the user table
	-- if the user table already exists the create table call will fail.
	-- this is ok, as that means teh table will not be over-written everytime you restart
	sql = xcore.xsql( "modules/tutorial_net_server/resources/auth.db" )
	sql:exe( "CREATE TABLE users (name text, password text)" )

	-- connection array?
	connections = {}

	print "[server] /init server"
end

function update()
	print "[server] update"
	net:update()
	packet = net:get()
	if packet ~= nil then
		print "[server] packet not null"
		if tonumber( packet:getType() ) == xcore.XPACKET_CONNECT then
			-- add client id to connection array, with status ov non-valid
			connections[ packet:getID() ] = 1 -- status = 1
		elseif tonumber( packet:getType() ) == xcore.XPACKET_DISCONNECT then
			-- reset client status in connection array
			connections[ packet:getID() ] = 0
		elseif tonumber( packet:getType() ) == xcore.XPACKET_VALIDATE then
			print "[server] got validate"
			-- validate? strip into un and pw
			i = string.find ( packet:getMessage(), ":")
			n = string.sub ( packet:getMessage(), 1, i-1 )
			p = string.sub ( packet:getMessage(), i+1, string.len( packet:getMessage() ) )

			-- check to see if name exists in database
			q = sql:exe( "SELECT * FROM users WHERE name = '" .. n .. "'" )
			-- sql:printAll()

			if q ~= nil then
				print "[server] found name"
				-- name found, check to see if passwords match
				q = sql:exe( "SELECT * FROM users WHERE name = '" .. n .. "' AND password = '" .. p .. "'" )
				if q ~= nil then
					print "[server] passwords match"
					-- if yes, then auth
					net:sendTo( xcore.XPACKET_AUTH, "allow", packet:getID() )
					connections[ packet:getID() ] = 2
				else
					print "[server] passwords do not match"
					-- if no, then deny
					net:sendTo( xcore.XPACKET_AUTH, "deny", packet:getID() )
				end
			else
				print "[server] create new user"
				-- name not found, add name and pw to database and send auth
				sql:exe( "INSERT INTO users (name, password) VALUES ('" .. n .. "', '" .. p .. "')" )
				net:sendTo( xcore.XPACKET_AUTH, "allow", packet:getID() )
				connections[ packet:getID() ] = 2
			end
			
		elseif tonumber( packet:getType() ) == xcore.XPACKET_MESSAGE then
			-- loop over connected array, sending only to user ids that have been validated.
			print "[server] got message"
			a = packet:getMessage()
			b = packet:getID()
			c = "client " .. b .. " : " .. a
			
			i = table.getn( connections )
			print ( "[server] num connections " .. i )
			for n = 1, i do
				print ( "[server] connections[n] " .. connections[n] )
				if connections[n] == 2 then
					net:sendTo( xcore.XPACKET_MESSAGE, c, n )
				end
			end

		else
			print ( "[server] unknown packet type: " .. packet:getType() )
		end
	end
end

-- required, but not used as server operates headless.
function render() end

-- end of file
